;--------------------------------------------;
;  TENTO PROGRAM ZAZBAMENA DO FLASH PAMETI   ;
;        CASOVY ZAZNAM Z KLAVESNICE          ;
;      pripojte PC aplikaci "Key_view"       ;
;--------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'

	#include	key_rec.inc
	#include	flash.inc
	#include	displej.inc
	#include	dskripty.inc
	#include	div16u.inc
	#include	tab_util.inc
	#include	vyber.inc

;---------------------------------------------
;||||||||||| KONSTANTY PROGRAMU ||||||||||||||
;---------------------------------------------


OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3 

#DEFINE	CLOCK	PORTC,4	; hodinovy vstup z klasvesnice
#DEFINE	KEYDATA	PORTC,5	; datovy vstup z klavesnice
#DEFINE	PREPINAC	PORTC,3	; spinac vodicu klavesnice
#DEFINE	KBREAK	PORTD,0	; definice prerusovaciho tlacitka

REC_ADR_	EQU	D'2048'

	CBLOCK	OFFRAM
	TML:1	; pro displej
	TMH:1
	DDATA:1

	AA:2	; pro skripty
	BB:2
	CC:2
	VD16U:1
	NUMFORM_:1

	KEYCOUNT:1	; cteni klavesnice
	KEYKOD:2
	TIME:2

	KKOD:2	; zaznamy
	KPOZICE:1
	MAXPOZICE:1

	REC_ADR:2	; menu volby pameti (makro "vyber")
	INDEX:1 
	ENDC

BLOK1	EQU	H'110'	; adresa zaznamu v RAM pameti (prvni byty)
BLOK2	EQU	H'190'	; adresa zaznamu v RAM pameti (druhe byt
MAXKKOD	EQU	D'64'	; maximalni pripustna delka kodu

	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI

	banksel	OPTION_REG
	BCF	OPTION_REG,T0CS
	BCF	OPTION_REG,PSA
	BCF	OPTION_REG,2
	BSF	OPTION_REG,1
	BSF	OPTION_REG,0
	banksel	PORTB
	BCF	PREPINAC
	banksel	TRISB
	BSF	CLOCK
	BSF	KEYDATA
	BCF	PREPINAC
	MOVLW	B'00100100'	; nastav vysilac pro...
	banksel	TXSTA		; ...asynchronni 8bitovy prenos
	MOVWF	TXSTA
	MOVLW	B'10010000'	; nastav prijimac pro...
	banksel	RCSTA		; ...asynchronni 8bitovy prijem
	MOVWF	RCSTA
	MOVLW	D'10'		; nastav komunikacni rychlost,...
	banksel	SPBRG		; ...v nasem pripade 115200 baudu
	MOVWF	SPBRG
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1
	banksel	TRISD
	MOVLW	B'00001111'	; ridici vodice jsou v rezimu vystupu,...
	MOVWF	TRISD	; ...prijimaci vodice jsou v rezimu vstupu
	banksel	0
	MOVWF	PORTD	; na vystupu ridicich vodicu jsou nuly (uroven "L")

	CALL	INITDISP	; spusteni displeje

	MOVLW	D'0'	; uvodni napis
	CALL	SKRIPT

	CLRF	KPOZICE	; resetovani zaznamu

LOOP	CALL	PRIJMOUT	; nacteme dalsi klavesovy vstup s casovou informaci
	BTFSC	STATUS,Z
	GOTO	KONECREC	; pokud neni dalsi vstup (preruseno tlacitkem), potom ukoncime zaznam

	MOVLW	D'155'	; synchronizace (pro udaj o case)
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	TIME+1,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	TIME,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG

	MOVF	TIME,W	; ulozeni promenne TIME do zaznamu
	MOVWF	KKOD
	MOVF	TIME+1,W
	MOVWF	KKOD+1
	CALL	KEY_REC

	BTFSS	STATUS,C
	GOTO	DO_FLASH
	MOVLW	D'133'	; synchronizace (pro kod klavesnice)
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KEYKOD+1,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KEYKOD,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG

	MOVF	KEYKOD,W	; ulozeni promenne KEYKOD do pameti
	MOVWF	KKOD
	MOVF	KEYKOD+1,W
	MOVWF	KKOD+1
	CALL	KEY_REC

	BTFSC	STATUS,C
	GOTO	LOOP	; navrat k testovani vtupu, pokud neni zaznam plny
	GOTO	DO_FLASH

KONECREC	INCF	KPOZICE,F ; pokud byl zaznam prerusen, musime vyrovnat stav ukazatele,...
			; ...aby udaval pocet polozek v zaznamu
; ZAZNAM DO FLASH
DO_FLASH	MOVF	KPOZICE,W	; ukazatel je vynulovan, ale ulozena delka zaznamu
	MOVWF	MAXPOZICE
	CLRF	KPOZICE
	; vyber pametove oblasti uzivatelem
	VYBER_	REC_ADR_,REC_ADR,D'64',INDEX,D'10',SKRIPT,D'1',DDELAY

	MOVF	REC_ADR+1,W
	banksel	EEADRH
	MOVWF	EEADRH
	banksel	REC_ADR
	MOVF	REC_ADR,W
	banksel	EEADR
	MOVWF	EEADR
	banksel	0

	CALL	KREAD_REC	; prvni cteni ze zaznamu ignorujeme (nedulezita informace)
	BTFSC	STATUS,Z
	GOTO	SKOK0
LOOP2	CALL	KREAD_REC	; cteme dalsi udaj (kod klavesnice)
	BTFSC	STATUS,Z
	GOTO	SKOK0	; pokud by bylo cteni neuspesne, potom koncime (konec zaznamu)

	MOVF	KKOD,W	; zapis nactene 14 bitove hodnoty do flash
	banksel	EEDATA
	MOVWF	EEDATA
	banksel	KKOD+1
	MOVF	KKOD+1,W
	banksel	EEDATH
	MOVWF	EEDATH
	banksel	0
	CALL	FWRITE

	banksel	EEADR	; inkrementace ukazatele do flash
	INCF	EEADR,F
	BTFSC	STATUS,Z
	INCF	EEADRH,F
	banksel	0

	CALL	KREAD_REC	; nacteni dalsiho zaznamu (cas)
	BTFSC	STATUS,Z
	GOTO	SKOK0	; pokud by bylo cteni neuspesne, potom koncime (konec zaznamu)

	MOVF	KKOD,W	; zapis nactene 14 bitove hodnoty do flash
	banksel	EEDATA
	MOVWF	EEDATA
	banksel	KKOD+1
	MOVF	KKOD+1,W
	banksel	EEDATH
	MOVWF	EEDATH
	banksel	0
	CALL	FWRITE

	banksel	EEADR	; inkrementace ukazatele do flash
	INCF	EEADR,F
	BTFSC	STATUS,Z
	INCF	EEADRH,F
	banksel	0
	GOTO	LOOP2
SKOK0
	banksel	EEDATA	; na konec flash zaznamu ulozime nulu
	CLRF	EEDATA
	CLRF	EEDATH
	CALL	FWRITE
	banksel	0

; PRECTENI FLASH ZAZNAMU
RUN_IT	MOVF	REC_ADR+1,W	; nastaveni zvolene adresy zaznamu
	banksel	EEADRH
	MOVWF	EEADRH
	banksel	REC_ADR
	MOVF	REC_ADR,W
	banksel	EEADR
	MOVWF	EEADR
	banksel	0

LOOP3	CALL	FREAD	; cteme lichou polozku (kod klavesnice)
	banksel	EEADR
	INCF	EEADR,F	; (inkrementace ukazatele)
	BTFSC	STATUS,Z
	INCF	EEADRH,F
	banksel	EEDATA
	MOVF	EEDATA,W	; zkopirovani do KKOD
	banksel	KKOD
	MOVWF	KKOD
	banksel	EEDATH
	MOVF	EEDATH,W
	banksel	KKOD+1
	MOVWF	KKOD+1

	MOVF	KKOD,F	; test nuly
	BTFSS	STATUS,Z
	GOTO	SKOK1
	MOVF	KKOD+1,F
	BTFSS	STATUS,Z
	GOTO	SKOK1
	GOTO	STOP	; pokud je nula, potom cteni konci

SKOK1	MOVLW	D'133'	; synchronizace (kod klavesnice)
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KKOD+1,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KKOD,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG

	CALL	FREAD	; cteme sudou polozku (cas)
	banksel	EEADR
	INCF	EEADR,F	; inkrementace
	BTFSC	STATUS,Z
	INCF	EEADRH,F
	banksel	EEDATA
	MOVF	EEDATA,W	; kopirovani do KKOD
	banksel	KKOD
	MOVWF	KKOD
	banksel	EEDATH
	MOVF	EEDATH,W
	banksel	KKOD+1
	MOVWF	KKOD+1

	MOVF	KKOD,F	; test nuly
	BTFSS	STATUS,Z
	GOTO	SKOK2
	MOVF	KKOD+1,F
	BTFSS	STATUS,Z
	GOTO	SKOK2
	GOTO	STOP	; pokuj je nula, potom cteni konci

SKOK2	MOVLW	D'155'	; synchronizace (hodnota casu)
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KKOD+1,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	MOVF	KKOD,W
	BTFSS	PIR1,TXIF
	GOTO	$ - 1
	MOVWF	TXREG
	GOTO	LOOP3	; opakovani cyklu

STOP	MOVLW	D'2'	; napis: "KONEC"
	CALL	SKRIPT
	GOTO	$

; CTENI KLAVESOVEHO KODU
PRIJMOUT	CLRF	TIME	; vynulovani casoveho zaznamu
	CLRF	TIME+1
	DECFSZ	TIME,F	; toto je uprava pro pripad nekterych klavesnic a pocitacu...
	GOTO	$ - 1
	BTFSS	CLOCK	; ...musime zkontrolovat, jestli uz skoncila odezva z pocitace (linka je volna)
	GOTO	$ - 1
	CLRF	TMR0	; resetujeme casovac,...
	BCF	INTCON,T0IF ; ...ale v podstate to neni nijak dulezite
CEKEJ	BTFSS	KBREAK	; testovani ukonceni tlacitkem
	GOTO	PRERUS
	BTFSS	CLOCK	; cekame na prichod "hodin"
	GOTO	TIME_REC	
	BTFSS	INTCON,T0IF ; pokud neprichazi, testujeme preteceni casovace
	GOTO	CEKEJ
	BCF	INTCON,T0IF ; pokud casovac pretekl,...
	INCFSZ	TIME,F	; ... inkrementujeme softwarovy 14bitovy citac
	GOTO	CEKEJ
	INCF	TIME+1,F
	BTFSS	TIME+1,6
	GOTO	CEKEJ
	MOVLW	D'255'	; ...pokud i ten pretece, nastavime maximalni hodnotu
	MOVWF	TIME
	MOVLW	D'63'
	MOVWF	TIME+1
TIME_REC	NENUL_	TIME	; cas nesmi byt nulovy
	MOVLW	D'11'
	MOVWF	KEYCOUNT	; zacina cteni kodu klavesnice
KEYLOOP	BTFSC	CLOCK	; cekame na hodinovy pulz
	GOTO	$ - 1
	BCF	KEYKOD+1,3; prenos bitu z datoveho sig. do bufferu
	BTFSS	CLOCK	; - || -
	GOTO	$ - 1	; - || -
	BTFSC	KEYDATA	; - || -
	BSF	KEYKOD+1,3	; - || -
	RRF	KEYKOD+1,F	; - || -
	RRF	KEYKOD,F		; - || -
	DECFSZ	KEYCOUNT,F	; opakovani cyklu, dokud neni bitovy buffer plny
	GOTO	KEYLOOP
	MOVF	KEYKOD+1,W	; v 16bit. promenne KEYKOD je cely kod...
	ANDLW	B'00000111'	; ...ale musi se "ocistit"
	MOVWF	KEYKOD+1
	BCF	STATUS,Z	; indikace, ze byl precten novy kod
	RETURN
PRERUS	CLRF	TIME	; pokud byl zaznam prerusen tlacitkem,...
	CLRF	TIME+1	; ...bude vysledek nulovy,...
	BSF	STATUS,Z	; ...vcetne indikace, ze nebyl precten novy kod
	RETURN 

; ULOZENI ZAZNAM DO STATICKE PAMETI
KEY_REC	KEY_REC_	KKOD, KPOZICE, BLOK1, BLOK2, MAXKKOD
	RETURN

; CTENI ZAZNAMU ZE STATICKE PAMETI
KREAD_REC	KRD_REC_	KKOD, KPOZICE, BLOK1, BLOK2, MAXPOZICE
	RETURN

; ZAPIS DO FLASH
FWRITE	FWRITE_	0,1
	RETURN

; CTENI Z FLASH
FREAD	FREAD_
	RETURN

; 16BITOVE DELENI
DIV16U	DIV16U_M	AA,BB,CC,VD16U 

; ZOBRAZOVACI SKRIPTY
SKRIPT	SKRIPT_	TABULKY, PUTZNAK, DPRIKAZ, NUMFORM_, DIV16U, AA, BB, CC
	RETURN

	; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS


;---------------------
; ||||||| DATA |||||||
;---------------------

TABULKY	DATA	NAPIS1
	DATA	NAPIS2
	DATA	NAPIS3

NAPIS1	POS_D	D'0'
	DE	"generujte klave-"
	POS_D	D'64'
	DE	" sovou posloup. "
	EOFS 

NAPIS2	POS_D	D'0'
	DE	"ulozit na index:"
	POS_D	d'64'
	DE	"            "
	PRINTV	INDEX,B'00111',0,0,0,1
	DBLOK	' ',D'3'
	EOFS

NAPIS3	POS_D	D'0'
	DE	"KONEC           "
	POS_D	D'64'
	DE	"                "
	EOFS

	END
