; PODPROGRAMY PRO VYBER ZAZNAMU Z FLASH PAMETI

; tento podprogram umozni uzivateli zvolit index (cislo) zaznamu
VYBER_	MACRO	CK_ADR_, K_ADR_, BLOK_, INDEX_, POCETKODU_, SKRIPT_, SCR_, PAUZA_
; CK_ADR_ - konstanta, ktera obsahuje adresu prvniho zaznamu (s indexem 0)
; K_ADR_  - promenna, ktera obsahuje adresu zvoleneho zaznamu
; BLOK_   - (konstanta) uzitna delka jednoho zaznamu (neni zde zapoctena "ukoncovaci nula")
; INDEX_  - (promenna) index zvoleneho zaznamu
; POCETKODU_ - (konstanta) dostupny pocet zaznamu
; SKRIPT_ - (konstanta) adresa skriptoveho interpreta
; SCR_    - (konstanta) index skriptu, ktery zobrazuje stav vyberu zaznamu
; PAUZA_  - (konstanta) adresa podprogramu na jednoduchou pauzu
	LOCAL	NULTY, LOOP, ZVYS, KONEC

	; nastavime multiplexni kavecnici do takzvaneho pasivniho rezimu
	; to znamena, ze nerozpoznavame jednotliva tlacitka, ale pouze
	; jednotlive radky tlacitek (napr. tlacitka "1","2","3","A" vyvolavaji
	; stejnou odezvu
	MOVLW	B'00001111'	; ridici vodice jsou v rezimu vystupu,...
	banksel	TRISD	; ...prijimaci vodice jsou v rezimu vstupu
	MOVWF	TRISD
	banksel	0
	MOVWF	PORTD	; na vystupu ridicich vodicu jsou nuly (uroven "L")
NULTY	CLRF	INDEX_	; nastavime prvni index...
	MOVLW	CK_ADR_ / D'256'	; ...a adresu prvniho zaznamu
	MOVWF	K_ADR_+1
	MOVLW	CK_ADR_ % D'256'
	MOVWF	K_ADR_
	MOVLW	SCR_	; aktualizujeme zobrazeni na displeji
	CALL	SKRIPT_
LOOP	BTFSS	PORTD,0	; indikuje prvni radek klavesnice (napr. tlacitko "A")
	GOTO	ZVYS	; pokud je stisknuto napr. "A", potom zvys volbu indexu
	BTFSS	PORTD,1	; indikuje druhy radek klavesnice (napr. tlacitko "B")
	GOTO	KONEC	; pokud je stisknuto napr. "B", potom ukonci vyber
	GOTO	LOOP	; opakuj testovani tlacitek

ZVYS	MOVLW	D'100'	; tlacitko bylo stisknuto, cekame na odezneni zakmitu 
	CALL	PAUZA_
	BTFSS	PORTD,0	; cekame na uvolneni tlacitka
	GOTO	$ - 1
	MOVLW	D'100'	; tlacitko bylo uvolneno, cekame na odezneni zakmitu
	CALL	PAUZA_
	INCF	INDEX_,F	; zvysujeme index zaznamu
	MOVF	INDEX_,W
	XORLW	POCETKODU_	; pokud velikost indexu pretekla mez,...
	BTFSC	STATUS,Z
	GOTO	NULTY	; ...tak se vratime na hodnotu nula (tedy resetujeme cely algoritmus)
	MOVLW	BLOK_+D'1'	; zvysime adresu zaznamu o celou delku jednoho bloku
	ADDWF	K_ADR_,F
	BTFSC	STATUS,C
	INCF	K_ADR_+1,F
	MOVLW	SCR_	; aktualizujeme zobrazeni na displeji
	CALL	SKRIPT_
	GOTO	LOOP	; vracime se a testujeme tlacitka...
KONEC
	ENDM

; kazdy zaznam pouziva vlastni nezavisly ukazatel...
; ...a tento podprogram je vsechny vynuluje
INDEXNUL_	MACRO	INDEX_, POCETKODU_, UKAZATELE_
; INDEX_ - (promenna) index prvniho "ukazatel" zaznamu
; POCETKODU_ - (konstanta) celkovy pocet zaznamu
; UKAZATELE_ - (konstanta) adresa prvniho ukazatele zaznamu
	LOCAL	LOOP

	CLRF	INDEX_	; index prvniho ukazatele
	bankisel	UKAZATELE_
LOOP	MOVLW	UKAZATELE_	; ukazatel na prvni "ukazatel"
	ADDWF	INDEX_,W
	MOVWF	FSR	; ukazatel na INDEX-ty "ukazatel"
	CLRF	INDF	; vynulovani tohoto "ukazatele"
	INCF	INDEX_,F	; prejdeme na dalsi "ukazatel"
	MOVF	INDEX_,W
	XORLW	POCETKODU_	; pokud index "ukazatele" pretekl, tak koncime,...
	BTFSS	STATUS,Z
	GOTO	LOOP	; ...jinak provedeme dalsi "nulovani"
	ENDM

; nastaveni pro prvni zaznam
PRVNI_K	MACRO	CK_ADR_, K_ADR_, INDEX_, UKAZATELE_
; CK_ADR_ - (konstanta) adresa prvniho zaznamu
; K_ADR_ - (promenna) adresa aktualniho zaznamu
; INDEX_ - (promenna} index aktualniho zaznamu
; UKAZATELE_ - (konstanta) adresa prvniho ukazatele zaznamu
	CLRF	INDEX_	; index prvniho zaznamu
	MOVLW	CK_ADR_ / D'256'
	MOVWF	K_ADR_+1
	MOVLW	CK_ADR_ % D'256'
	MOVWF	K_ADR_	; adresa prvniho zaznamu
	bankisel	UKAZATELE_	; nastaveni adresy prvniho ukazatele
	MOVLW	UKAZATELE_
	MOVWF	FSR
	ENDM

; tento podprogram nas posune na dalsi zaznam (vcetne ukazatele)
; pokud jiz neni dalsi zaznam, potom se nastavi priznak Z = 1
DALSI_K	MACRO	CK_ADR_, K_ADR_, BLOK_, INDEX_, POCETKODU_, UKAZATELE_
; CK_ADR_ - (konstanta) adresa prvniho zaznamu
; K_ADR_ - (promenna) adresa aktualniho zaznamu
; BLOK_  - (konstanta) uzitna delka jednoho zaznamu (neni zde zapoctena "ukoncovaci nula")
; INDEX_ - (promenna} index aktualniho zaznamu
; POCETKODU_ - (konstanta) dostupny pocet zaznamu
; UKAZATELE_ - (konstanta) adresa prvniho ukazatele zaznamu
	LOCAL	KONEC

	INCF	INDEX_,F	; zvyseni indexu zaznamu
	MOVF	INDEX_,W
	XORLW	POCETKODU_	; pokud index pretekl, potom koncime (priznak Z = 1)
	BTFSC	STATUS,Z
	GOTO	KONEC
	MOVLW	BLOK_+D'1'	; zvysime adresu zaznamu
	ADDWF	K_ADR_,F
	BTFSC	STATUS,C
	INCF	K_ADR_+1,F
	bankisel	UKAZATELE_	; nastaveni adresy ukazatele (podle indexu)
	MOVLW	UKAZATELE_
	ADDWF	INDEX_,W
	MOVWF	FSR
	BCF	STATUS,Z	; (priznak Z = 0 - "jeste neni konec")
KONEC
	ENDM
